diff --git a/Makefile.am b/Makefile.am
index ceaa04f96a4e11ead6dd6d7909c33bb570218599..4e7ec694747ea971d2db77c05b9716d820a4f41d 100644
--- a/Makefile.am
+++ b/Makefile.am
@@ -15,6 +15,7 @@ BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
 CHECK_MAN = $(top_srcdir)/autotools/check-man
+CHECK_VERSION = $(top_srcdir)/autotools/check-version
 REPLACE_VARS_SED = autotools/replace_vars.sed
 
 hypervisordir = $(pkgpythondir)/hypervisor
@@ -283,6 +284,7 @@ EXTRA_DIST = \
 	autotools/check-python-code \
 	autotools/check-man \
 	autotools/check-tar \
+	autotools/check-version \
 	autotools/docbook-wrapper \
 	autotools/gen-coverage \
 	autotools/testrunner \
@@ -636,6 +638,7 @@ check-dirs: $(BUILT_SOURCES)
 
 check-local: check-dirs
 	$(CHECK_PYTHON_CODE) $(check_python_code)
+	$(CHECK_VERSION) $(VERSION)
 
 .PHONY: lint
 lint: ganeti $(BUILT_SOURCES)
diff --git a/autotools/check-version b/autotools/check-version
new file mode 100755
index 0000000000000000000000000000000000000000..1a2e2b38255275ea1b97af1739747fec518a30b2
--- /dev/null
+++ b/autotools/check-version
@@ -0,0 +1,50 @@
+#!/bin/bash
+#
+
+# Copyright (C) 2010 Google Inc.
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+#
+# This program is distributed in the hope that it will be useful, but
+# WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+# General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+set -e
+
+# Enable Bash-specific patterns
+shopt -s extglob
+
+readonly version=$1
+readonly numpat='+([0-9])'
+
+case "$version" in
+  # Format "x.y.z"
+  $numpat.$numpat.$numpat) : ;;
+
+  # Format "x.y.z~rcN" or "x.y.z~betaN" for N > 0
+  $numpat.$numpat.$numpat~@(rc|beta)[1-9]*([0-9])) : ;;
+
+  *)
+    echo "Invalid version format: $version" >&2
+    exit 1
+  ;;
+esac
+
+readonly newsver="Version ${version/~/}"
+
+if ! grep -q -x "$newsver" NEWS
+then
+  echo "Unable to find heading '$newsver' in NEWS" >&2
+  exit 1
+fi
+
+exit 0